#include "classes.h"

CGame::CGame() {

	// BITMAOINFO+J[e[upm
	lpbiScreen=(LPBITMAPINFO)GlobalAlloc(GPTR,sizeof(BITMAPINFO)+255*sizeof(RGBQUAD));
	lpbiScroll=(LPBITMAPINFO)GlobalAlloc(GPTR,sizeof(BITMAPINFO)+255*sizeof(RGBQUAD));

	/* Q[ʃrbg}bvBITMAPINFO\́|8bpp/544*544sNZ */
	lpbiScreen->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	lpbiScreen->bmiHeader.biWidth=544;
	lpbiScreen->bmiHeader.biHeight=-544;
	lpbiScreen->bmiHeader.biPlanes=1;
	lpbiScreen->bmiHeader.biBitCount=8;
	lpbiScreen->bmiHeader.biCompression=BI_RGB;

	/* XN[prbg}bvBITMAPINFO\́|8bpp/576*576sNZ */
	lpbiScroll->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	lpbiScroll->bmiHeader.biWidth=576;
	lpbiScroll->bmiHeader.biHeight=-576;
	lpbiScroll->bmiHeader.biPlanes=1;
	lpbiScroll->bmiHeader.biBitCount=8;
	lpbiScroll->bmiHeader.biCompression=BI_RGB;

}

bool CGame::init(HDC hdc) {

	hScreen=CreateDIBSection(hdc,lpbiScreen,DIB_RGB_COLORS,(LPVOID*)&lpScreen,NULL,0);
	hdcScreen=CreateCompatibleDC(hdc);
	SelectObject(hdcScreen,hScreen);

	hScroll=CreateDIBSection(hdc,lpbiScroll,DIB_RGB_COLORS,(LPVOID*)&lpScroll,NULL,0);
	hdcScroll=CreateCompatibleDC(hdc);
	SelectObject(hdcScroll,hScroll);

	map.draw(lpScreen,player.getX()-8,player.getY()-8,17,17);

	iDx=0;
	iDy=0;
	iSx=0;
	iSy=0;
	fOnScroll=false;
	iScStep=2;
	iCount=0;

	return true;

}

bool CGame::setColorTable(LPBYTE lpArg) {

	if (lpArg==NULL)
		return false;

	CopyMemory((LPBYTE)lpbiScreen+sizeof(BITMAPINFOHEADER),lpArg,1024);
	CopyMemory((LPBYTE)lpbiScroll+sizeof(BITMAPINFOHEADER),lpArg,1024);

	return true;

}

bool CGame::setMap(LPBYTE lpArg) {

	map.setMap(lpArg);

	return true;

}

bool CGame::setMapChips(LPBYTE lpArg) {

	return map.setChips(lpArg);

}

bool CGame::setPlayerBMP(LPBYTE lpArg,int iArg) {

	if (lpArg==NULL)
		return false;

	return player.setBMP(lpArg,iArg);

}

bool CGame::setPlayerPos(int iArg1,int iArg2) {

	return player.setPos(iArg1,iArg2);

}

bool CGame::draw(HDC hdc,int iArg1,int iArg2) {

	player.draw(lpScreen);

	BitBlt(hdc,iArg1,iArg2,544,544,hdcScreen,0,0,SRCCOPY);

	return true;

}

bool CGame::action() {

	bool fReturn=false;

	if ((++iCount % 30)==0) { /* 30^[ɕ\LN^؂ւ */

		player.setIndex((player.getIndex() ^ 1) & 0x1);

		if (!fOnScroll)
			map.draw(lpScreen,player.getX()-8,player.getY()-8,17,17);

		fReturn=true;

	}

	if (fOnScroll) {

		scroll();
		fReturn=true;

	}

	return fReturn;

}

bool CGame::scroll() {

	int iVx=0,iVy=0;

    /* XN[JnɃXN[̈lpScrollɕ` */
	if (iSx==0 && iSy==0) {

		if (iDx<0)
			map.draw(lpScroll,player.getX()-9,player.getY()-8,18,18);
		if (iDx>0)
			map.draw(lpScroll,player.getX()-8,player.getY()-8,18,18);
		if (iDy<0)
			map.draw(lpScroll,player.getX()-8,player.getY()-9,18,18);
		if (iDy>0)
			map.draw(lpScroll,player.getX()-8,player.getY()-8,18,18);

	}

	iSx+=iDx;
	iSy+=iDy;

	if (iDx<0)
		iVx=31+iSx;
	if (iDx>0)
		iVx=iSx;
	if (iDy<0)
		iVy=31+iSy;
	if (iDy>0)
		iVy=iSy;

	if (iSx<-31) {

		player.setX(player.getX()-1);
		StretchBlt(hdcScreen,0,0,544,544,hdcScroll,0,0,544,544,SRCCOPY);

		fOnScroll=false;
		iDx=0;
		iSx=0;

	}

	if (iSx>31) {

		player.setX(player.getX()+1);
		StretchBlt(hdcScreen,0,0,544,544,hdcScroll,32,0,544,544,SRCCOPY);

		fOnScroll=false;
		iDx=0;
		iSx=0;

	}

	if (iSy<-31) {

		player.setY(player.getY()-1);
		StretchBlt(hdcScreen,0,0,544,544,hdcScroll,0,0,544,544,SRCCOPY);

		fOnScroll=false;
		iDy=0;
		iSy=0;

	}

	if (iSy>31) {

		player.setY(player.getY()+1);
		StretchBlt(hdcScreen,0,0,544,544,hdcScroll,0,32,544,544,SRCCOPY);

		fOnScroll=false;
		iDy=0;
		iSy=0;

	}

	/* XN[ȂAXN[̈炵ȂlpScreenɕ` */
	if (fOnScroll)
		StretchBlt(hdcScreen,0,0,544,544,hdcScroll,iVx,iVy,544,544,SRCCOPY);

	return true;

}

bool CGame::OnVK_UP() {

	if (fOnScroll || !map.enter(player.getX(),player.getY()-1))
		return false;

	iDy=-iScStep;
	fOnScroll=true;

	return true;

}

bool CGame::OnVK_RIGHT() {

	if (fOnScroll ||!map.enter(player.getX()+1,player.getY()))
		return false;

	iDx=iScStep;
	fOnScroll=true;

	return true;

}

bool CGame::OnVK_DOWN() {

	if (fOnScroll ||!map.enter(player.getX(),player.getY()+1))
		return false;

	iDy=iScStep;
	fOnScroll=true;

	return true;

}

bool CGame::OnVK_LEFT() {

	if (fOnScroll ||!map.enter(player.getX()-1,player.getY()))
		return false;

	iDx=-iScStep;
	fOnScroll=true;

	return true;

}

CGame::~CGame() {

	DeleteDC(hdcScreen);
	DeleteDC(hdcScroll);
	DeleteObject(hScreen);
	DeleteObject(hScreen);

	GlobalFree(lpbiScreen);
	GlobalFree(lpbiScroll);

}
