#include <windows.h>

class CPlayer {

public:

	CPlayer();

	virtual int getX();
	virtual int getY();
	virtual DWORD getIndex();

	virtual bool setPos(int,int);
	virtual bool setIndex(DWORD);

	virtual bool setX(int);
	virtual bool setY(int);

	virtual bool draw(LPBYTE);
	virtual bool setBMP(LPBYTE,int);

	virtual ~CPlayer();

private:

	int iX,iY,dwIndex;
	LPBYTE lpPixels[2];

};

class CMap {

public:

	CMap();

	bool draw(LPBYTE,int,int,int,int);
	bool setChips(LPBYTE);
	bool setMap(LPBYTE);
	int getChip(int,int);
	bool enter(int,int);

	~CMap();

private:

	LPBYTE lpBuf,lpMap,lpChips[64];

};

class CGame {

public:

	CGame();

	bool init(HDC);

	bool setColorTable(LPBYTE);
	bool setMap(LPBYTE);
	bool setMapChips(LPBYTE);
	bool setPlayerBMP(LPBYTE,int);

	int getPlayerX();
	int getPlayerY();

	bool setPlayerPos(int,int);

	bool draw(HDC,int,int);

	bool action();

	bool OnVK_UP();
	bool OnVK_RIGHT();
	bool OnVK_DOWN();
	bool OnVK_LEFT();

	~CGame();

private:

	bool scroll();

	LPBYTE lpScreen,lpScroll;
	LPBITMAPINFO lpbiScreen,lpbiScroll;
	HBITMAP hScreen,hScroll;
	HDC hdcScreen,hdcScroll;
	RGBQUAD *lpRGB;

	CPlayer player;
	CMap map;
	int iX,iY,iDx,iDy,iSx,iSy,iScStep,iCount;
	bool fOnScroll;

};
